#include "Board.h"
#include "Sound.h"

static int GHban;
static int GHhaikei;
static int GHblack;
static int GHwhite;
static int GHmasume;

static int masuY,masuX;			//}Xڂ̘g点邽߂̍W

static int CPU_BanData[ CPU_BAN_HEIGHT ][ CPU_BAN_WIDTH ] = {0};

static int BanData[ BAN_HEIGHT ][ BAN_WIDTH ] =
{
	{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 2, 1, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 1, 2, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } 
} ;

//{[hɊւ摜f[^̃[h
void Board_init(){										
	GHban = LoadGraph(TEXT("摜/IZՖ.png"));
	GHhaikei = LoadGraph(TEXT("摜/wi.png"));
	GHblack = LoadGraph(TEXT("摜/R}.png"));
	GHwhite = LoadGraph(TEXT("摜/R}.png"));
	GHmasume = LoadGraph(TEXT("摜/}Xڌ.png"));

	int y,x;

	int init_BanData[ BAN_HEIGHT ][ BAN_WIDTH ] =		//{[h̏
	{
		{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 2, 1, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 1, 2, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } 
	} ;

	for(y = 0; y < BAN_HEIGHT ; y++){				//{[h̏
		for( x = 0; x < BAN_WIDTH ; x++){
			BanData[y][x] = init_BanData[y][x];
		}
	}
	Board_CPU_BanData_push(FIRST);
}

//{[h`֐
void Board_Draw(){									

	int y, x;
	int black = 0;
	int white = 0;

	int color;

	//wi̕`
	DrawGraph(0,0,GHhaikei,FALSE);

	//R}ƃ{[h̕`
	for( y = 1 ; y < BAN_HEIGHT -1 ; y++ )
	{
		for( x = 1 ; x < BAN_WIDTH -1 ; x++ )
		{
			switch(BanData[ y ][ x ] )
			{
			case BAN : 
				DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHban, TRUE);
				if( (y == masuY) && (x == masuX )){
					DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHmasume, TRUE);
				}
				break;
			case BLACK :
				black++;
				DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHban, TRUE);
				DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHblack, TRUE);
				if( (y == masuY) && (x == masuX )){
					DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHmasume, TRUE);
				}
				break;
			case WHITE :
				white++;
				DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHban, TRUE);
				DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHwhite, TRUE);
				if( (y == masuY) && (x == masuX )){
					DrawGraph(y*BAN_SIZE, x*BAN_SIZE, GHmasume, TRUE);
				}
				break;
			}
		}
	}
	// `悷镶̑ݒ
	SetFontThickness( 9 );

	// `悷镶̕ZbgύX
	ChangeFont( "lr " ) ;

	//F̐ݒ
	color = GetColor(  0, 0, 0 ) ;

	DrawFormatString( 500, 10, color, "̃R}F %d \n", black );
	DrawFormatString( 500, 30, color, "̃R}F %d \n", white );
}

//R}u邩m߂֐
int Board_Search (int x ,int y ,int koma){				

	int dx = x;									//uƂR}̍WdxBɓĂ
	int dy = y;
	int vx = 0;
	int vy = 0;
	int flip_count = 0;
	int aitekoma;

	int i = 0;
	int j = 0;
	int k = 0;
	int m = 0;

	if(koma == BLACK){
		aitekoma = WHITE;
	}else{
		aitekoma = BLACK;
	}

	if( x < 1 || y < 1 || x > (BAN_WIDTH - 2) || y > (BAN_HEIGHT - 2))return flip_count;			//{[h͈͓̔ǂ

	if(BanData[x][y] != BAN)return flip_count;

	for(i = -1, x = dx+i; x <= (dx + 1) ; x = dx+ ++i){										//uƂĂR}̍W͂ɑ̃R}邩mF
		for(j = -1 ,y = dy+j; y <= (dy+1) ; y = dy+ ++j){
			if(BanData[x][y] == aitekoma){													
				vx = (x - dx),vy = (y - dy);												//̃R}Ԃ邩mFĂ߂
				for(k = 1; BanData[dx + k*vx][dy + k*vy] == aitekoma; k++){};				//Ԃ邩߂Ă
				if(BanData[dx + k*vx][dy + k*vy] == koma){
					for(m = 0; m < k; m++){
						BanData[dx + m*vx][dy + m*vy] = FLAG;							//̃R}܂ŒH蒅ЂԂR}̏ꏊɃtO𗧂ĂĂ
					}
					flip_count += 1;
				}
			}
		}
	}
	return flip_count;
}

//R}ЂԂ֐
void Board_Flip(int koma){
	int y,x;

	for( y = 1 ; y < BAN_HEIGHT -1 ; y++ ){		//tO̗Ăꏊς
		for( x = 1 ; x < BAN_WIDTH -1 ; x++ ){
			if(BanData[y][x] == FLAG){
				BanData[y][x] = koma;
				Sound_Board_koma();					//R}ԂʉĐ
			}
		}
	}
}

//v[[̓͊֐
int Board_Check_Mouse(int Mykoma){			

	int end = 0;

	int oldinput = 0;		
	int nowinput = 0;
	int edgeinput = 0;
	int mouseX = 0;
	int mouseY = 0;
	int x = 0; 
	int	y = 0;

	// }EX̓͏XV
	oldinput = nowinput ;
	nowinput = GetMouseInput() ;
	edgeinput = nowinput & ~oldinput ;
	GetMousePoint( &mouseX, &mouseY ) ;

	// }X̍WZo
	x = ( mouseX - BAN_LEFTUP_X ) / BAN_SIZE ;
	y = ( mouseY - BAN_LEFTUP_Y ) / BAN_SIZE ;

	// }X̍W󂯓n
	masuX = y;
	masuY = x;

	// }EX̍{^ꂽSearch֐ŒuꏊmF
	if( ( edgeinput & MOUSE_INPUT_LEFT ) != 0 ){
		switch(Board_Search(x,y,Mykoma)){
			case 0:
				end = 0;
				break;
			default:
				Board_Flip(Mykoma);
				Board_CPU_BanData_push(FIRST);
				end = 1;
				break;
		}
	}
	return end;
}

//uR}邩ǂׂ֐
int Board_Check_End(int koma){
	int copyX,copyY;
	int Check_BanData[BAN_HEIGHT][ BAN_WIDTH ];			

	for(copyY = 1; copyY < BAN_HEIGHT-1 ; copyY++){				//{[h̏OăRs[Ă
		for( copyX = 1; copyX < BAN_WIDTH-1 ; copyX++){
			Check_BanData[copyY][copyX] = BanData[copyY][copyX];
		}
	}

	int y, x;
	int check_count = 0;
	
	for( y = 1 ; y < BAN_HEIGHT -1 ; y++ ){		//WÂT[`֐֑
		for( x = 1 ; x < BAN_WIDTH -1 ; x++ ){
			if(Board_Search(x,y,koma) >= 1){
				check_count += 1;
			}
		}
	}

	for(copyY = 1; copyY < BAN_HEIGHT-1 ; copyY++){				//{[h̏߂
		for( copyX = 1; copyX < BAN_WIDTH-1 ; copyX++){
			BanData[copyY][copyX] = Check_BanData[copyY][copyX];
		}
	}
	return check_count;
}

//ǂ炪
int Board_Check_Winner(int Mykoma){

	int y,x,user=0,cpu=0,black=0,white=0;

	enum winner winner = NOONE;

	//R}𐔂グ
	for(y = 1 ; y < BAN_WIDTH -1 ; ++y){
		for(x = 1 ; x < BAN_HEIGHT -1 ; ++x){
			switch(BanData[y][x]){
				case BLACK:
					++black;
					break;
				case WHITE:
					++white;
					break;
				default :
					break;
			}
		}
	}

	if(Mykoma == BLACK){							//v[[̃R}ꍇ
        user = black,
        cpu = white;
	}else{											//ꍇ
        user = white,
        cpu = black;
	}

	if(user > cpu){
		winner = USER;
	}else if(cpu > user){
		winner = CPU;
	}else{
		winner = DRAW;
	}
	return winner;
}

//CPUvlp̃{[h֐iCPU{[h񂩂Ճf[^ցj
void Board_CPU_BanData_pop(int ordinal){
	int i,j;					//BanDataJEgpϐ
	int h,w;					//CPU_BanDataJEgpϐin_j
	int w_end,h_end;			//CPU_BanDataJEgpϐiI_j
	int dh,dw;					//CPU_BanDatan_̏pϐ

	switch(ordinal){			//push֐ĂяoOɂ炪Ăяoꂽꍇ̑Ώ
		case FIRST:
			if(CPU_BanData[0][0] != -1){
				MessageBox(NULL,TEXT("[ȃG[܂BQ[I܂B"),TEXT("ERROR"),MB_OK),
				DxLib_End();
			}break;

		case SECOND:
			if(CPU_BanData[10][10] != -1){
				MessageBox(NULL,TEXT("[ȃG[܂BQ[I܂B"),TEXT("ERROR"),MB_OK),
				DxLib_End();
			}break;
	}

	switch(ordinal){		
		case FIRST:				//FIRSTȂ09܂ł̔zgp
			h = 0;
			w = 0;
			dh = h;
			dw = w;
			h_end = BAN_HEIGHT;
			w_end = BAN_WIDTH;
			break;

		case SECOND:			//SECONDȂ1020܂ł̔zgp
			h = BAN_HEIGHT;
			w = BAN_WIDTH;
			dh = h;
			dw = w;
			h_end = CPU_BAN_HEIGHT;
			w_end = CPU_BAN_WIDTH;
			break;
	}

	for( i=0,h=dh; (h < h_end) && (i < BAN_HEIGHT) ; h++,i++){				//CPŨ{[h̏n
		for( j=0,w=dw; (w < w_end) && (j < BAN_WIDTH) ; w++,j++){
			BanData[i][j] = CPU_BanData[h][w];
		}
	}
}

//CPUvlp̃{[h֐iՃf[^CPU{[hցj
void Board_CPU_BanData_push(int ordinal){
	int i,j;					//BanDataJEgpϐ
	int h,w;					//CPU_BanDataJEgpϐin_j
	int w_end,h_end;			//CPU_BanDataJEgpϐiI_j
	int dh,dw;					//CPU_BanDatan_̏pϐ

	switch(ordinal){
		case FIRST:				//FIRSTȂ010܂ł̔zgp
			h = 0;
			w = 0;
			dh = h;
			dw = w;
			h_end = BAN_HEIGHT;
			w_end = BAN_WIDTH;
			break;

		case SECOND:			//SECONDȂ1020܂ł̔zgp
			h = BAN_HEIGHT;
			w = BAN_WIDTH;
			dh = h;
			dw = w;
			h_end = CPU_BAN_HEIGHT;
			w_end = CPU_BAN_WIDTH;
			break;
	}

	for( i=0,h=dh; (h < h_end) && (i < BAN_HEIGHT) ; h++,i++){				//{[h̏ۂĂ
		for( j=0,w=dw; (w < w_end) && (j < BAN_WIDTH) ; w++,j++){
			CPU_BanData[h][w] = BanData[i][j];
		}
	}
}