#include "Game.h"
#include "CPU_AI.h"
#include "Board.h"

//vg^Cv錾
static int Game_Select();

enum game_state { INIT, USER_TURN, CPU_TURN, USER_PASS, CPU_PASS, GAME_END };
enum game_state game_state = INIT;

//v[[A肩肩I֐
static int Game_Select(){
	if(MessageBox(NULL,TEXT("܂?"),TEXT("I"),MB_YESNO) == IDYES){			
		return USER_TURN;
	}else{
		return CPU_TURN;
	}
}

//Q[̐is
int Game_main(){
	
	static int Mykoma,Tekikoma;

	enum winner winner = NOONE;

	switch (game_state){
		case INIT:
			if(Game_Select()==USER_TURN){
				game_state = USER_TURN,
				Mykoma = BLACK,
				Tekikoma = WHITE;
			}else{
				game_state = CPU_TURN,
				Mykoma = WHITE,
				Tekikoma = BLACK;
				break;
			}

		case USER_TURN: 
			switch(Board_Check_End(Mykoma)){					//uꏊ邩`FbN
				case 0:
					game_state = USER_PASS;
					break;

				default:
					if(Board_Check_Mouse(Mykoma) == 1){				//v[[̓̓^[
						game_state = CPU_TURN;
					}else{
						game_state = USER_TURN;
						break;
					}
			}break;

		case CPU_TURN: 
			switch(Board_Check_End(Tekikoma)){				//uꏊ邩`FbN
				case 0:
					game_state = CPU_PASS;
					break;

				default:
					if(CPU_input(Tekikoma) == 1){					//CPU̓̓^[
						game_state = USER_TURN;
					}else{
						game_state = CPU_TURN;
						break;
					}
			}break;

		case USER_PASS:										//Iǂ̔i[U[̃pXj
			game_state = CPU_TURN;
			if(Board_Check_End(Tekikoma) == 0){
				game_state = GAME_END;
			}else{
				MessageBox(NULL,TEXT("pX܂"),TEXT("Oh..."),MB_OK);
			break;
			}

		case CPU_PASS:										//Iǂ̔iCPŨpXj
			game_state = USER_TURN;
			if(Board_Check_End(Mykoma) == 0){
				game_state = GAME_END;
			}else{
				MessageBox(NULL,TEXT("pXł"),TEXT("CPŨ^["),MB_OK);
			break;
			}

		case GAME_END:
			switch(Board_Check_Winner(Mykoma)){			//ҔAl𑗂
				case USER:
					winner = USER;break;
				case CPU:
					winner = CPU;break;
				case DRAW:
					winner = DRAW;break;
			}
			game_state = INIT;
			break;

		default : MessageBox(NULL,TEXT("\ʃG["),TEXT("ERROR"),MB_OK);
			break;
	}
	return winner;
}